<?php 
  /**
  * Sistema Automatizado para la Planificación EstratÃ©gico-Situacional en la Administración Pública Venezolana
  * @file proyecto_operativo_seguimiento.module
  * Drupal part Module to code proyectos operativos module
  * Copyright 2012 Sistema Automatizado para la Planificación EstratÃ©gico-Situacional en la Administración PÃºblica Venezolana (CENDITEL)
  *
  * This program is free software; you can redistribute it and/or modify
  * it under the terms of the GNU General Public License as published by
  * the Free Software Foundation; either version 2 of the License, or
  * (at your option) any later version.
  * 
  * This program is distributed in the hope that it will be useful,
  * but WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  * GNU General Public License for more details.
  * 
  * You should have received a copy of the GNU General Public License
  * along with this program; if not, write to the Free Software
  * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
  *
  * @author CENDITEL Merida - Ing. Diego Uzcategui
  * @date 2013-02-07 // (anno-mes-dia)
  * @author CENDITEL Merida - Phd Juan Vizcarrondo (Actualizacion de funciones)
  * @update 2016-12-14 // (anno-mes-dia)
  * @version 0.1
  *
  */

/**
 * Pagina que muestra el historial de cambios de estados
 * revisado 1 abril 2013
 */
function historial_cambiodeestado_seg_proyecto_page($node, $mes = 0) {
  $meses = json_decode(MESES);
  $output = '';
  $output .= '<br>';
  $tablas = array();
  $header = array();
  $header[] = array('data' => t('Mes')); 
  $header[] = array('data' => t('Accionado')); 
  $header[] = array('data' => t('Fecha')); 
  $header[] = array('data' => t('Actor')); 
  $header[] = array('data' => t('Comentario'));
  $header[] = array('data' => t('Transición de Estados'));

  $mes_seguimiento = variable_get('accion_especifica_de_proyecto_seguimiento_mes_seguimiento', 0);
  $mes_final = variable_get('seguimiento_proyectos_cantidad_meses_seguimiento', 0);
  for ($i=1;  $i<=count($meses); $i++) {
    $rows = array();
    $mesesList[] = $meses[$i -1];
    $query = "SELECT id_seg from {seguimiento_proyecto} where nid = %d and mes = %d";//consulta seguimiento
    $queryResult = db_query ($query, $node->nid, $i);
    $seg_proyecto = db_fetch_object($queryResult);
   if ($seg_proyecto  && $seg_proyecto->id_seg) {
      $query2 = "SELECT t.*, u.name from {seguimiento_proyecto_transiciones_estados} AS t LEFT JOIN {users} AS u ON u.uid = t.uid where t.id_seg = %d order by date desc";//consulta seguimiento
      $queryResult2 = db_query($query2, $seg_proyecto->id_seg);
      $estados = _obtener_estados_seguimiento_mes();
      while ($transiciones_estado_seg = db_fetch_object ($queryResult2)) {
        $row = array();
        $row[] = array('data' => $meses[$i -1],);
        $estado_anterior = isset($transiciones_estado_seg->estado_ant)? $transiciones_estado_seg->estado_ant : '-';
        $estado_anterior_nombre = $estados['states'][$estado_anterior];
        $estado_actual = isset($transiciones_estado_seg->estado)? $transiciones_estado_seg->estado : '-';
        $estado_actual_nombre = $estados['states'][$estado_actual];
        $accionado = variable_get('proyectos_operativos_state_d_' . $current . '_' . $transiciones_estado_seg->estado, FALSE)? t(variable_get('proyectos_operativos_state_tdevueltos', 'Devuelto a @state'), array('@state' => $estado_actual_nombre)) : t(variable_get('proyectos_operativos_state_tndevueltos', 'Enviado a @state'), array('@state' => $estado_actual_nombre));
        $row[] = array('data' => $accionado,);
        $fecha_cambio_estado = isset($transiciones_estado_seg->date)? $transiciones_estado_seg->date : '-';
        $fecha_formato_cambio_estado = format_date($fecha_cambio_estado);
        $row[] = array('data' => $fecha_formato_cambio_estado,);
        $row[] = array('data' => $transiciones_estado_seg->name,);
        $comentario = isset($transiciones_estado_seg->comentario)? $transiciones_estado_seg->comentario : '-';
        $row[] = array('data' => $comentario,);
        $row[] = array('data' => $estado_anterior_nombre.' => '.$estado_actual_nombre,);
        $rows[] = $row;
      }
    }
    if (!count($rows)) {
      $header = array();
      $header[] = array('data' => t('Accionado')); 
      $header[] = array('data' => t('Fecha')); 
      $header[] = array('data' => t('Actor')); 
      $header[] = array('data' => t('Comentario'));
      $header[] = array('data' => t('Transición de Estados'));
      $row = array();
      $row[] = array('data' => t("No se posee seguimiento registrado"), 'colspan' => 6);
      $rows[] = $row;
    }
    $tablas[]= '<fieldset><label>' . $meses[$i -1] . '</label>'  . theme('table', $header, $rows) . '</fieldset>';
  }

  drupal_set_title(t('Historial de cambios de estados del Seguimiento de Proyecto para el mes "@nombre_mes"', array('@nombre_mes' => implode(", ", $mesesList))));
  if (count($tablas)) {
    $output .= '<fieldset><legend>' . t('Historial transiciones de cambio de estado del seguimiento del Proyecto') . '</legend>';
    $output .= implode('', $tablas).'</fieldset>';
  }

  return $output;
}
